// Supabase Client Initialization
const supabaseUrl = 'https://rsmrozgkeieopetprsid.supabase.co';
const supabaseKey = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJzdXBhYmFzZSIsInJlZiI6InJzbXJvemdrZWllb3BldHByc2lkIiwicm9sZSI6ImFub24iLCJpYXQiOjE3NDg2OTUwMTEsImV4cCI6MjA2NDI3MTAxMX0.dnUG6UG1XTyrZbI3bHQL95jDws_dLjp6AXSbAmBESM8';

const supabase = supabase.createClient(supabaseUrl, supabaseKey);

const supabase = supabase.createClient('https://rsmrozgkeieopetprsid.supabase.co', 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJzdXBhYmFzZSIsInJlZiI6InJzbXJvemdrZWllb3BldHByc2lkIiwicm9sZSI6ImFub24iLCJpYXQiOjE3NDg2OTUwMTEsImV4cCI6MjA2NDI3MTAxMX0.dnUG6UG1XTyrZbI3bHQL95jDws_dLjp6AXSbAmBESM8');

// Global App Object
const app = {
    // --- App State Variables ---
    currentLang: localStorage.getItem('appLang') || 'en',
    narrationEnabled: JSON.parse(localStorage.getItem('narrationEnabled')) || false,
    speechRate: parseFloat(localStorage.getItem('speechRate')) || 0.7,
    selectedVoice: null,
    voices: [],
    customAudio: null, // For playing custom sound files
    elderUserId: localStorage.getItem('elderUserId') || null, // For the elder's device to know its ID
    elderUserDocRef: null, // Supabase equivalent of Firebase Firestore document reference for the elder user

    // --- Cached DOM Elements ---
    dom: {}, // Object to hold cached DOM elements, populated in cacheDomElements()

    // --- Language Strings (Expanded with new keys and placeholders) ---
    lang: {
        en: {
            header: "Memory Aid App",
            toggleDarkMode: "Toggle Dark Mode",
            changeLanguage: "Change Language",
            toggleNarrationOn: "🔊 Narration ON",
            toggleNarrationOff: "🔇 Narration OFF",
            caregiverLogin: "Caregiver Login",
            clockButton: "Clock",
            remindersButton: "Reminders",
            familyButton: "Family",
            callButton: "Call",
            moneyButton: "Money",
            meetButton: "Meet",
            notesButton: "Notes",
            helpButton: "Help",
            narrationSettingsTitle: "Narration Settings",
            voiceSelectLabel: "Select Voice:",
            speechRateLabel: "Speech Speed:",
            createPasswordPrompt: "CREATE new caregiver email & password:",
            confirmPasswordPrompt: "Confirm new caregiver password:",
            passwordSetSuccess: "Password set successfully!",
            passwordMismatch: "Passwords do not match or empty. Please try again.",
            enterPasswordPrompt: "Enter caregiver password:",
            wrongPassword: "Wrong password",
            settingsSaved: "Settings saved remotely.",
            caregiverConfig: "Caregiver Configuration",
            caregiverUserNameLabel: "User's Name:",
            caregiverLocationLabel: "User's Timezone / Location (e.g., Asia/Tehran):",
            caregiverEmergencyContactLabel: "Emergency Contact (Name & Number):",
            caregiverMeetLinkLabel: "Google Meet Link:",
            caregiverDailyReminderLabel: "Daily Reminder:",
            caregiverUploadImageLabel: "Upload Family Image + Caption:",
            imageCaptionPlaceholder: "Enter caption",
            caregiverQuickButtonsLabel: "Quick Access Buttons (comma separated):",
            caregiverCustomSoundLabel: "Custom Sound File (MP3):",
            caregiverYouTubeVideoLabel: "YouTube Video ID or URL:",
            saveSettings: "Save Settings",
            langSetTo: "Language set to: ",
            narrationEnabledMsg: "Narration enabled",
            narrationDisabledMsg: "Narration disabled",
            reminderText: "Reminder:",
            emergencyContactText: "Emergency Contact:",
            googleMeetText: "Google Meet:",
            joinCall: "Join Call",
            timeDisplay: "Time ({{location}}): {{time}} | Persian Date: {{date}}",
            invalidLocation: "Invalid location/timezone",
            noSettings: "Please ask your caregiver to set up this app.",
            speechHello: "Hello",
            speechReminder: "Here is your daily reminder:",
            speechEmergency: "Your emergency contact is:",
            speechNotSupported: "Speech synthesis not supported in this browser.",
            darkModeEnabled: "Dark mode enabled.",
            lightModeEnabled: "Light mode enabled.",
            voiceChangeAnnounce: "Voice changed to {{voiceName}}.",
            speedChangeAnnounce: "Speech speed set to {{speed}} times.",
            currentClockText: "Current time in {{location}} is {{time}}, on {{date}}.",
            openingReminders: "Opening reminders.",
            openingFamily: "Opening family section.",
            openingCallOptions: "Opening call options.",
            openingMoneyNotes: "Opening money notes.",
            openingGoogleMeet: "Opening Google Meet in a new tab.",
            openingPersonalNotes: "Opening personal notes.",
            openingHelpGuide: "Opening help guide.",
            openingYouTubeVideo: "Opening helpful video.",
            windowClosed: "Window closed.",
            noReminders: "No reminders yet.",
            youHaveReminders: "You have {{count}} reminder{{s}}.",
            newReminderTextLabel: "New Reminder:",
            newReminderPlaceholder: "Enter reminder text...",
            addReminderBtnText: "Add Reminder",
            reminderAdded: "Reminder added: {{text}}",
            enterReminderPrompt: "Please enter a reminder!",
            deleteReminderConfirm: "Are you sure you want to delete this reminder?",
            reminderDeleted: "Reminder deleted: {{text}}",
            reminderDeleteCancelled: "Reminder deletion cancelled.",
            selectContact: "Select a contact",
            callInstruction: "Click \"Call\" to attempt a call (requires device support).",
            attemptingToCall: "Attempting to call {{contactName}}.",
            selectContactToCall: "Please select a contact to call.",
            moneyNotesPlaceholder: "e.g., 'Paid rent on 1st', 'Owe John $50', 'Bank PIN is 1234' (be careful with sensitive info!)",
            moneyNotesSaved: "Money notes saved.",
            personalNotesPlaceholder: "Write your personal notes here...",
            personalNotesSaved: "Personal notes saved.",
            helpContentHTML: `
                <p>Welcome to your Memory Aid App!</p>
                <p>This app is designed to help you remember important information and tasks.</p>
                <ul>
                  <li><strong>Clock:</strong> Shows the current time and date.</li>
                  <li><strong>Reminders:</strong> Add and manage your daily reminders. They are saved automatically!</li>
                  <li><strong>Family:</strong> View family photos and caregiver-set contacts.</li>
                  <li><strong>Call:</strong> Quickly dial pre-defined contacts.</li>
                  <li><strong>Money:</strong> Keep track of important money-related notes.</li>
                  <li><strong>Meet:</strong> Opens your Google Meet link for online meetings.</li>
                  <li><strong>Notes:</strong> Save personal notes that will be remembered between sessions.</li>
                  <li><strong>Help:</strong> You're here!</li>
                </ul>
                <p>Use the 🌞 / 🌙 button to toggle between light and dark modes.</p>
                <p>Use the 🔊 / 🔇 button to turn narration on or off.</p>
                <p>You can also select the voice and adjust the speech speed in Narration Settings.</p>
                <p>All your notes and reminders are saved directly in your browser and will be available next time you open the app on this device.</p>
            `,
            closeButton: "Close",
            remindersModalTitle: "Reminders",
            familyModalTitle: "Family",
            callModalTitle: "Call",
            moneyModalTitle: "Money",
            notesModalTitle: "Personal Notes",
            helpModalTitle: "Help Guide",
            youtubeModalTitle: "Helpful Video",
            familyPlaceholderMsg: "This section displays family photos or important contact information. (Set by caregiver)"
        },
        fa: {
            header: "برنامه کمک حافظه",
            toggleDarkMode: "تغییر حالت شب و روز",
            changeLanguage: "تغییر زبان",
            toggleNarrationOn: "🔊 روایت روشن",
            toggleNarrationOff: "🔇 روایت خاموش",
            caregiverLogin: "ورود سرپرست",
            clockButton: "ساعت",
            remindersButton: "یادآوری‌ها",
            familyButton: "خانواده",
            callButton: "تماس",
            moneyButton: "پول",
            meetButton: "جلسه",
            notesButton: "یادداشت‌ها",
            helpButton: "راهنما",
            narrationSettingsTitle: "تنظیمات گفتار",
            voiceSelectLabel: "انتخاب صدا:",
            speechRateLabel: "سرعت گفتار:",
            createPasswordPrompt: "ایجاد ایمیل و رمز عبور جدید سرپرست:",
            confirmPasswordPrompt: "تایید رمز عبور جدید سرپرست:",
            passwordSetSuccess: "رمز عبور با موفقیت تنظیم شد!",
            passwordMismatch: "رمزهای عبور مطابقت ندارند یا خالی هستند. لطفا دوباره تلاش کنید.",
            enterPasswordPrompt: "رمز عبور سرپرست را وارد کنید:",
            wrongPassword: "رمز عبور اشتباه است",
            settingsSaved: "تنظیمات از راه دور ذخیره شد.",
            caregiverConfig: "پیکربندی سرپرست",
            caregiverUserNameLabel: "نام کاربر:",
            caregiverLocationLabel: "منطقه زمانی / مکان کاربر (مثال: Asia/Tehran):",
            caregiverEmergencyContactLabel: "تماس اضطراری (نام و شماره):",
            caregiverMeetLinkLabel: "لینک گوگل میت:",
            caregiverDailyReminderLabel: "یادآوری روزانه:",
            caregiverUploadImageLabel: "بارگذاری عکس خانوادگی + توضیح:",
            imageCaptionPlaceholder: "توضیح را وارد کنید",
            caregiverQuickButtonsLabel: "دکمه‌های دسترسی سریع (با کاما جدا کنید):",
            caregiverCustomSoundLabel: "فایل صوتی سفارشی (MP3):",
            caregiverYouTubeVideoLabel: "شناسه یا لینک ویدیوی یوتیوب:",
            saveSettings: "ذخیره تنظیمات",
            langSetTo: "زبان تنظیم شد به: ",
            narrationEnabledMsg: "روایت فعال شد",
            narrationDisabledMsg: "روایت غیرفعال شد",
            reminderText: "یادآوری:",
            emergencyContactText: "تماس اضطراری:",
            googleMeetText: "گوگل میت:",
            joinCall: "پیوستن به تماس",
            timeDisplay: "ساعت ({{location}}): {{time}} | تاریخ شمسی: {{date}}",
            invalidLocation: "مکان/منطقه زمانی نامعتبر",
            noSettings: "لطفاً سرپرست خود را برای تنظیم این برنامه بخواهید.",
            speechHello: "سلام",
            speechReminder: "اینجا یادآوری روزانه شماست:",
            speechEmergency: "تماس اضطراری شما:",
            speechNotSupported: "تبدیل متن به گفتار در این مرورگر پشتیبانی نمی‌شود.",
            darkModeEnabled: "حالت تاریک فعال شد.",
            lightModeEnabled: "حالت روشن فعال شد.",
            voiceChangeAnnounce: "صدا به {{voiceName}} تغییر یافت.",
            speedChangeAnnounce: "سرعت گفتار به {{speed}} برابر تنظیم شد.",
            currentClockText: "ساعت فعلی در {{location}} ${time} است، تاریخ ${date}.",
            openingReminders: "باز کردن یادآوری‌ها.",
            openingFamily: "باز کردن بخش خانواده.",
            openingCallOptions: "باز کردن گزینه‌های تماس.",
            openingMoneyNotes: "باز کردن یادداشت‌های مالی.",
            openingGoogleMeet: "باز کردن گوگل میت در یک تب جدید.",
            openingPersonalNotes: "باز کردن یادداشت‌های شخصی.",
            openingHelpGuide: "باز کردن راهنمای کمک.",
            openingYouTubeVideo: "باز کردن ویدیوی مفید.",
            windowClosed: "پنجره بسته شد.",
            noReminders: "هنوز یادآوری ندارید.",
            youHaveReminders: "شما {{count}} یادآوری دارید.",
            newReminderTextLabel: "یادآوری جدید:",
            newReminderPlaceholder: "متن یادآوری را وارد کنید...",
            addReminderBtnText: "افزودن یادآوری",
            reminderAdded: "یادآوری اضافه شد: {{text}}",
            enterReminderPrompt: "لطفا یک یادآوری وارد کنید!",
            deleteReminderConfirm: "آیا مطمئن هستید که می‌خواهید این یادآوری را حذف کنید؟",
            reminderDeleted: "یادآوری حذف شد: {{text}}",
            reminderDeleteCancelled: "حذف یادآوری لغو شد.",
            selectContact: "یک مخاطب را انتخاب کنید",
            callInstruction: "برای برقراری تماس کلیک کنید (نیاز به پشتیبانی دستگاه دارد).",
            attemptingToCall: "در حال تلاش برای تماس با {{contactName}}.",
            selectContactToCall: "لطفاً یک مخاطب را برای تماس انتخاب کنید.",
            moneyNotesPlaceholder: "مثال: 'اجاره در اول ماه پرداخت شد'، '۵۰ دلار به جان بدهکارم'، 'پین بانک ۱۲۳۴' (با اطلاعات حساس دقت کنید!)",
            moneyNotesSaved: "یادداشت‌های مالی ذخیره شد.",
            personalNotesPlaceholder: "یادداشت‌های شخصی خود را اینجا بنویسید...",
            personalNotesSaved: "یادداشت‌های شخصی ذخیره شد.",
            helpContentHTML: `
                <p>به برنامه کمک حافظه خود خوش آمدید!</p>
                <p>این برنامه برای کمک به شما در به خاطر سپردن اطلاعات و وظایف مهم طراحی شده است.</p>
                <ul>
                  <li><strong>ساعت:</strong> زمان و تاریخ فعلی را نمایش می‌دهد.</li>
                  <li><strong>یادآوری‌ها:</strong> یادآوری‌های روزانه خود را اضافه و مدیریت کنید. آنها به طور خودکار ذخیره می‌شوند!</li>
                  <li><strong>خانواده:</strong> مشاهده عکس‌های خانوادگی و مخاطبین تعیین شده توسط سرپرست.</li>
                  <li><strong>تماس:</strong> به سرعت با مخاطبین از پیش تعریف شده تماس بگیرید.</li>
                  <li><strong>پول:</strong> یادداشت‌های مهم مربوط به پول را پیگیری کنید.</li>
                  <li><strong>جلسه:</strong> لینک گوگل میت شما را برای جلسات آنلاین باز می‌کند.</li>
                  <li><strong>یادداشت‌ها:</strong> یادداشت‌های شخصی را ذخیره کنید که بین جلسات به خاطر سپرده می‌شوند.</li>
                  <li><strong>راهنما:</strong> شما اینجا هستید!</li>
                </ul>
                <p>از دکمه 🌞 / 🌙 برای تغییر بین حالت روشن و تاریک استفاده کنید.</p>
                <p>از دکمه 🔊 / 🔇 برای روشن یا خاموش کردن روایت استفاده کنید.</p>
                <p>همچنین می‌توانید صدا را انتخاب کرده و سرعت گفتار را در تنظیمات گفتار تنظیم کنید.</p>
                <p>تمام یادداشت‌ها و یادآوری‌های شما مستقیماً در مرورگر شما ذخیره می‌شوند و دفعه بعد که برنامه را در این دستگاه باز کنید در دسترس خواهند بود.</p>
            `,
            closeButton: "بستن",
            remindersModalTitle: "یادآوری‌ها",
            familyModalTitle: "خانواده",
            callModalTitle: "تماس",
            moneyModalTitle: "پول",
            notesModalTitle: "یادداشت‌های شخصی",
            helpModalTitle: "راهنمای کمک",
            youtubeModalTitle: "ویدیوی مفید",
            familyPlaceholderMsg: "این بخش عکس‌های خانوادگی یا اطلاعات تماس مهم را نمایش می‌دهد. (توسط سرپرست تنظیم می‌شود)"
        }
    },

    // --- Initialization Function ---
    init: function() {
        this.cacheDomElements(); // Cache DOM elements first
        this.loadTheme(); // Load theme preference
        this.loadNarrationPreference(); // Load narration preference

        // Populate voices once available
        if (speechSynthesis.onvoiceschanged !== undefined) {
            speechSynthesis.onvoiceschanged = () => {
                this.populateVoiceList();
                this.setInitialVoice();
            };
        } else {
            this.populateVoiceList();
            this.setInitialVoice();
        }
        this.loadSpeechSettings(); // Load speech rate setting

        this.updateUIforLanguage(); // Set initial UI language based on preference

        // Initialize Supabase session and data loading
        supabase.auth.getSession().then(({ data: { session } }) => {
            if (session) {
                this.elderUserId = session.user.id; // If caregiver is logged in, use their UID as elder ID
                localStorage.setItem('elderUserId', this.elderUserId);
                this.elderUserDocRef = supabase.from('memory_settings'); // Reference to the table
                this.dom.caregiverSection.classList.remove('hidden'); // Show caregiver section if logged in
                this.loadCaregiverSettings();
                this.listenForElderSettingsChanges(); // Start real-time listener for caregiver's device
            } else {
                // If no caregiver session, try to load elder view based on stored ID
                if (this.elderUserId) {
                    // If elder ID exists from previous session, load user view
                    this.elderUserDocRef = supabase.from('memory_settings'); // Reference to the table
                    this.listenForElderSettingsChanges(); // Start real-time listener for elder's device
                    this.renderUserView(); // Initial render for elder
                } else {
                    // No stored ID, no caregiver session, show initial user message
                    this.renderUserView();
                }
            }
        }).catch(error => {
            console.error("Error getting Supabase session:", error);
            // Fallback to showing user view with no settings message
            this.renderUserView();
        });

        // Start clock update
        setInterval(() => {
            // Use current form value for location if caregiver section is open, otherwise default or last loaded
            const location = this.dom.locationInput.value || (this.currentElderData?.location || 'America/Toronto');
            this.updateClock(location);
        }, 1000);

        // Event listener for caregiver form submission
        this.dom.caregiverForm.addEventListener('submit', (e) => this.handleCaregiverFormSubmit(e));

        // Event listener for closing modals when clicking outside
        window.onclick = (event) => {
            if (event.target.classList.contains('modal')) {
                const modalId = event.target.id;
                const modalType = modalId.replace('Modal', '');
                this.hideModal(modalType);
            }
        };

        // PWA: Register Service Worker
        if ('serviceWorker' in navigator) {
            navigator.serviceWorker.register('/service-worker.js')
                .then(reg => {
                    console.log('Service Worker Registered:', reg);
                })
                .catch(err => {
                    console.error('Service Worker Registration Failed:', err);
                });
        }
    },

    // --- DOM Caching ---
    cacheDomElements: function() {
        this.dom.statusMessageDiv = document.getElementById('statusMessage');
        this.dom.mainHeader = document.getElementById('mainHeader');
        this.dom.darkModeToggleBtn = document.getElementById('darkModeToggleBtn');
        this.dom.languageToggleBtn = document.getElementById('languageToggleBtn');
        this.dom.narrationToggleBtn = document.getElementById('narrationToggleBtn');
        this.dom.caregiverLoginBtn = document.getElementById('caregiverLoginBtn'); // Updated ID

        this.dom.caregiverSection = document.getElementById('caregiverSection');
        this.dom.caregiverConfigTitle = this.dom.caregiverSection.querySelector('h2');
        this.dom.caregiverForm = document.getElementById('caregiverForm');
        this.dom.userNameInput = document.getElementById('userName');
        this.dom.locationInput = document.getElementById('location');
        this.dom.emergencyContactInput = document.getElementById('emergencyContact');
        this.dom.meetLinkInput = document.getElementById('meetLink');
        this.dom.dailyReminderTextarea = document.getElementById('dailyReminder');
        this.dom.familyImageInput = document.getElementById('familyImage');
        this.dom.imageCaptionInput = document.getElementById('imageCaption');
        this.dom.quickButtonsInput = document.getElementById('quickButtons');
        this.dom.customSoundInput = document.getElementById('customSound');
        this.dom.youtubeVideoIdInput = document.getElementById('youtubeVideoId'); // New YouTube input
        this.dom.saveSettingsBtn = document.getElementById('saveSettingsBtn');

        this.dom.userView = document.getElementById('userView');
        this.dom.clockDisplay = document.getElementById('clockDisplay');
        this.dom.dynamicQuickButtonsContainer = document.getElementById('dynamicQuickButtonsContainer'); // New container

        this.dom.narrationSettingsTitle = document.getElementById('narrationSettingsTitle');
        this.dom.voiceSelectLabel = document.getElementById('voiceSelectLabel');
        this.dom.speechRateLabel = document.getElementById('speechRateLabel');
        this.dom.voiceSelect = document.getElementById('voiceSelect');
        this.dom.speechRateInput = document.getElementById('speechRate');
        this.dom.speechRateValueSpan = document.getElementById('speechRateValue');

        // Modals
        this.dom.remindersModal = document.getElementById('remindersModal');
        this.dom.remindersListUl = document.querySelector('#remindersList ul');
        this.dom.newReminderTextInput = document.getElementById('newReminderText');
        this.dom.addReminderBtn = document.getElementById('addReminderBtn');
        this.dom.yourRemindersTitle = document.getElementById('yourRemindersTitle');
        this.dom.remindersModalTitle = document.getElementById('remindersModalTitle');
        this.dom.newReminderTextLabel = document.getElementById('newReminderTextLabel');

        this.dom.familyModal = document.getElementById('familyModal');
        this.dom.familyModalTitle = document.getElementById('familyModalTitle');
        this.dom.familyContentDiv = document.getElementById('familyContent');
        this.dom.familyPlaceholderMsg = document.getElementById('familyPlaceholderMsg');
        this.dom.closeFamilyModalBtn = document.getElementById('closeFamilyModalBtn');

        this.dom.callModal = document.getElementById('callModal');
        this.dom.phoneNumberSelect = document.getElementById('phoneNumber');
        this.dom.callModalTitle = document.getElementById('callModalTitle');
        this.dom.phoneNumberLabel = document.getElementById('phoneNumberLabel');
        this.dom.selectContactOption = document.getElementById('selectContactOption');
        this.dom.callInstruction = document.getElementById('callInstruction');
        this.dom.makeCallBtn = document.getElementById('makeCallBtn');
        this.dom.closeCallModalBtn = document.getElementById('closeCallModalBtn');

        this.dom.moneyModal = document.getElementById('moneyModal');
        this.dom.moneyNotesTextarea = document.getElementById('moneyNotes');
        this.dom.moneyModalTitle = document.getElementById('moneyModalTitle');
        this.dom.moneyNotesLabel = document.getElementById('moneyNotesLabel');
        this.dom.saveMoneyNotesBtn = document.getElementById('saveMoneyNotesBtn');
        this.dom.closeMoneyModalBtn = document.getElementById('closeMoneyModalBtn');

        this.dom.notesModal = document.getElementById('notesModal');
        this.dom.personalNotesTextarea = document.getElementById('personalNotes');
        this.dom.notesModalTitle = document.getElementById('notesModalTitle');
        this.dom.personalNotesLabel = document.getElementById('personalNotesLabel');
        this.dom.savePersonalNotesBtn = document.getElementById('savePersonalNotesBtn');
        this.dom.closeNotesModalBtn = document.getElementById('closeNotesModalBtn');

        this.dom.helpModal = document.getElementById('helpModal');
        this.dom.helpContentDiv = document.getElementById('helpContent');
        this.dom.helpModalTitle = document.getElementById('helpModalTitle');
        this.dom.closeHelpModalBtn = document.getElementById('closeHelpModalBtn');

        this.dom.youtubeModal = document.getElementById('youtubeModal');
        this.dom.youtubeModalTitle = document.getElementById('youtubeModalTitle');
        this.dom.youtubePlayerContainer = document.getElementById('youtubePlayerContainer');
        this.dom.closeYoutubeModalBtn = document.getElementById('closeYoutubeModalBtn');
    },

    // --- Utility Function for UI Feedback ---
    showStatusMessage: function(message, type = 'success') {
        if (!this.dom.statusMessageDiv) return;
        this.dom.statusMessageDiv.innerText = message;
        this.dom.statusMessageDiv.style.backgroundColor = type === 'error' ? '#f44336' : '#4CAF50';
        this.dom.statusMessageDiv.classList.remove('hidden');
        setTimeout(() => {
            this.dom.statusMessageDiv.classList.add('hidden');
        }, 3000);
    },

    // --- Theme Toggling ---
    toggleTheme: function() {
        document.body.classList.toggle('dark-mode');
        const isDarkMode = document.body.classList.contains('dark-mode');
        localStorage.setItem('darkMode', isDarkMode ? 'enabled' : 'disabled');
        this.speak(isDarkMode ? this.lang[this.currentLang].darkModeEnabled : this.lang[this.currentLang].lightModeEnabled);
    },

    loadTheme: function() {
        if (localStorage.getItem('darkMode') === 'enabled') {
            document.body.classList.add('dark-mode');
        }
    },

    // --- Language Toggling and UI Update ---
    toggleLanguage: function() {
        this.currentLang = this.currentLang === 'en' ? 'fa' : 'en';
        localStorage.setItem('appLang', this.currentLang);
        this.showStatusMessage(this.lang[this.currentLang].langSetTo + (this.currentLang === 'en' ? 'English' : 'فارسی'));
        this.updateUIforLanguage();
        this.renderUserView(); // Re-render user view to apply new language
    },

    updateUIforLanguage: function() {
        const l = this.lang[this.currentLang];

        this.dom.mainHeader.innerText = l.header;
        this.dom.darkModeToggleBtn.innerText = l.toggleDarkMode;
        this.dom.languageToggleBtn.innerText = l.changeLanguage;
        this.dom.narrationToggleBtn.innerText = this.narrationEnabled ? l.toggleNarrationOn : l.toggleNarrationOff;
        this.dom.caregiverLoginBtn.innerText = l.caregiverLogin;

        // Update main grid buttons
        document.querySelector('.btn-text[data-key="clockButton"]').innerText = l.clockButton;
        document.querySelector('.btn-text[data-key="remindersButton"]').innerText = l.remindersButton;
        document.querySelector('.btn-text[data-key="familyButton"]').innerText = l.familyButton;
        document.querySelector('.btn-text[data-key="callButton"]').innerText = l.callButton;
        document.querySelector('.btn-text[data-key="moneyButton"]').innerText = l.moneyButton;
        document.querySelector('.btn-text[data-key="meetButton"]').innerText = l.meetButton;
        document.querySelector('.btn-text[data-key="notesButton"]').innerText = l.notesButton;
        document.querySelector('.btn-text[data-key="helpButton"]').innerText = l.helpButton;

        // Narration Settings Labels
        this.dom.narrationSettingsTitle.innerText = l.narrationSettingsTitle;
        this.dom.voiceSelectLabel.innerText = l.voiceSelectLabel;
        this.dom.speechRateLabel.innerText = l.speechRateLabel;
        this.dom.speechRateValueSpan.textContent = `${this.speechRate.toFixed(1)}x`;

        // Caregiver Section Labels
        this.dom.caregiverConfigTitle.innerText = l.caregiverConfig;
        document.querySelector('label[for="userName"]').innerText = l.caregiverUserNameLabel;
        document.querySelector('label[for="location"]').innerText = l.caregiverLocationLabel;
        this.dom.locationInput.placeholder = l.caregiverLocationLabel.includes('e.g.') ? 'e.g., Asia/Tehran' : '';
        document.querySelector('label[for="emergencyContact"]').innerText = l.caregiverEmergencyContactLabel;
        document.querySelector('label[for="meetLink"]').innerText = l.caregiverMeetLinkLabel;
        document.querySelector('label[for="dailyReminder"]').innerText = l.caregiverDailyReminderLabel;
        document.querySelector('label[for="familyImage"]').innerText = l.caregiverUploadImageLabel;
        this.dom.imageCaptionInput.placeholder = l.imageCaptionPlaceholder;
        document.querySelector('label[for="quickButtons"]').innerText = l.caregiverQuickButtonsLabel;
        document.querySelector('label[for="customSound"]').innerText = l.caregiverCustomSoundLabel;
        document.querySelector('label[for="youtubeVideoId"]').innerText = l.caregiverYouTubeVideoLabel; // New YouTube label
        this.dom.youtubeVideoIdInput.placeholder = l.caregiverYouTubeVideoLabel.includes('ID or URL') ? 'YouTube Video ID or URL' : '';
        this.dom.saveSettingsBtn.innerText = l.saveSettings;

        // Modals Labels
        if (this.dom.remindersModalTitle) this.dom.remindersModalTitle.innerText = l.remindersModalTitle;
        if (this.dom.newReminderTextLabel) this.dom.newReminderTextLabel.innerText = l.newReminderTextLabel;
        if (this.dom.newReminderTextInput) this.dom.newReminderTextInput.placeholder = l.newReminderPlaceholder;
        if (this.dom.addReminderBtn) this.dom.addReminderBtn.innerText = l.addReminderBtnText;
        if (this.dom.yourRemindersTitle) this.dom.yourRemindersTitle.innerText = l.youHaveReminders.replace('{{count}}', '').replace('{{s}}', '');

        if (this.dom.familyModalTitle) this.dom.familyModalTitle.innerText = l.familyModalTitle;
        if (this.dom.familyPlaceholderMsg) this.dom.familyPlaceholderMsg.innerText = l.familyPlaceholderMsg;
        if (this.dom.closeFamilyModalBtn) this.dom.closeFamilyModalBtn.innerText = l.closeButton;

        if (this.dom.callModalTitle) this.dom.callModalTitle.innerText = l.callModalTitle;
        if (this.dom.phoneNumberLabel) this.dom.phoneNumberLabel.innerText = l.phoneNumberLabel;
        if (this.dom.selectContactOption) this.dom.selectContactOption.innerText = l.selectContact;
        if (this.dom.callInstruction) this.dom.callInstruction.innerText = l.callInstruction;
        if (this.dom.makeCallBtn) this.dom.makeCallBtn.innerText = l.callButton;
        if (this.dom.closeCallModalBtn) this.dom.closeCallModalBtn.innerText = l.closeButton;

        if (this.dom.moneyModalTitle) this.dom.moneyModalTitle.innerText = l.moneyModalTitle;
        if (this.dom.moneyNotesLabel) this.dom.moneyNotesLabel.innerText = l.moneyNotesLabel;
        if (this.dom.moneyNotesTextarea) this.dom.moneyNotesTextarea.placeholder = l.moneyNotesPlaceholder;
        if (this.dom.saveMoneyNotesBtn) this.dom.saveMoneyNotesBtn.innerText = l.saveSettings;
        if (this.dom.closeMoneyModalBtn) this.dom.closeMoneyModalBtn.innerText = l.closeButton;

        if (this.dom.notesModalTitle) this.dom.notesModalTitle.innerText = l.notesModalTitle;
        if (this.dom.personalNotesLabel) this.dom.personalNotesLabel.innerText = l.personalNotesLabel;
        if (this.dom.personalNotesTextarea) this.dom.personalNotesTextarea.placeholder = l.personalNotesPlaceholder;
        if (this.dom.savePersonalNotesBtn) this.dom.savePersonalNotesBtn.innerText = l.saveSettings;
        if (this.dom.closeNotesModalBtn) this.dom.closeNotesModalBtn.innerText = l.closeButton;

        if (this.dom.helpModalTitle) this.dom.helpModalTitle.innerText = l.helpModalTitle;
        if (this.dom.helpContentDiv) this.dom.helpContentDiv.innerHTML = l.helpContentHTML;
        if (this.dom.closeHelpModalBtn) this.dom.closeHelpModalBtn.innerText = l.closeButton;

        if (this.dom.youtubeModalTitle) this.dom.youtubeModalTitle.innerText = l.youtubeModalTitle;
        if (this.dom.closeYoutubeModalBtn) this.dom.closeYoutubeModalBtn.innerText = l.closeButton;

        document.body.classList.remove('lang-en', 'lang-fa');
        document.body.classList.add(`lang-${this.currentLang}`);
        document.body.style.direction = (this.currentLang === 'fa') ? 'rtl' : 'ltr';

        this.renderReminders(); // Re-render reminders with new language
        this.loadMoneyNotes(); // Reload to update placeholder
        this.loadPersonalNotes(); // Reload to update placeholder
    },

    // --- Narration Toggling & Controls ---
    toggleNarration: function() {
        this.narrationEnabled = !this.narrationEnabled; // Corrected typo: this.narationEnabled -> this.narrationEnabled
        localStorage.setItem('narrationEnabled', this.narrationEnabled);
        if (this.narrationEnabled) {
            this.dom.narrationToggleBtn.textContent = this.lang[this.currentLang].toggleNarrationOn;
            this.speak(this.lang[this.currentLang].narrationEnabledMsg);
        } else {
            this.dom.narrationToggleBtn.textContent = this.lang[this.currentLang].toggleNarrationOff;
            window.speechSynthesis.cancel(); // Stop any ongoing speech
            this.speak(this.lang[this.currentLang].narrationDisabledMsg);
        }
    },

    loadNarrationPreference: function() {
        const savedPreference = localStorage.getItem('narrationEnabled');
        if (savedPreference !== null) {
            this.narrationEnabled = (savedPreference === 'true');
        }
        if (this.dom.narrationToggleBtn) {
            this.dom.narrationToggleBtn.textContent = this.narrationEnabled ? this.lang[this.currentLang].toggleNarrationOn : this.lang[this.currentLang].toggleNarrationOff;
        }
    },

    // Speech Synthesis Functions
    speak: function(text) {
        if (!this.narrationEnabled) {
            return;
        }
        if (!window.speechSynthesis) {
            this.showStatusMessage(this.lang[this.currentLang].speechNotSupported, 'error');
            return;
        }
        if (speechSynthesis.speaking) {
            speechSynthesis.cancel();
        }

        const utterance = new SpeechSynthesisUtterance(text);
        utterance.rate = this.speechRate;
        utterance.lang = this.currentLang === 'fa' ? 'fa-IR' : 'en-US';

        // Try to find the selected voice, or a default for the current language
        if (this.selectedVoice && this.selectedVoice.lang.startsWith(utterance.lang)) {
            utterance.voice = this.selectedVoice;
        } else {
            const voiceForLang = this.voices.find(voice => voice.lang.startsWith(utterance.lang) && voice.default);
            if (voiceForLang) {
                utterance.voice = voiceForLang;
            } else {
                const anyVoiceForLang = this.voices.find(voice => voice.lang.startsWith(utterance.lang));
                if (anyVoiceForLang) {
                    utterance.voice = anyVoiceForLang;
                }
            }
        }
        window.speechSynthesis.speak(utterance);
    },

    speakAll: function(data) {
        const l = this.lang[this.currentLang];
        let combined = `${l.speechHello} ${data.userName || ''}. `;
        if (data.dailyReminder) {
            combined += `${l.speechReminder} ${data.dailyReminder}. `;
        }
        if (data.emergencyContact) {
            combined += `${l.speechEmergency} ${data.emergencyContact}. `;
        }
        this.speak(combined);
    },

    // Voice Selection & Rate Control
    populateVoiceList: function() {
        if (!this.dom.voiceSelect) return;
        this.dom.voiceSelect.innerHTML = '';
        this.voices = speechSynthesis.getVoices();

        this.voices.forEach(voice => {
            const option = document.createElement('option');
            option.textContent = `${voice.name} (${voice.lang})`;
            option.value = voice.name;
            option.dataset.lang = voice.lang;
            this.dom.voiceSelect.appendChild(option);
        });
        this.setInitialVoice();
    },

    setInitialVoice: function() {
        const savedVoiceName = localStorage.getItem('selectedVoiceName');
        if (!this.dom.voiceSelect) return;

        if (savedVoiceName) {
            this.selectedVoice = this.voices.find(voice => voice.name === savedVoiceName);
            if (this.selectedVoice) {
                this.dom.voiceSelect.value = savedVoiceName;
            } else {
                this.findAndSetDefaultVoice();
            }
        } else {
            this.findAndSetDefaultVoice();
        }
    },

    findAndSetDefaultVoice: function() {
        if (!this.dom.voiceSelect) return;

        const faVoice = this.voices.find(v => v.lang.startsWith('fa-IR') && v.default) || this.voices.find(v => v.lang.startsWith('fa-IR'));
        const enVoice = this.voices.find(v => v.lang.startsWith('en-US') && v.default) || this.voices.find(v => v.lang.startsWith('en-US'));

        if (this.currentLang === 'fa' && faVoice) {
            this.selectedVoice = faVoice;
            this.dom.voiceSelect.value = faVoice.name;
        } else if (this.currentLang === 'en' && enVoice) {
            this.selectedVoice = enVoice;
            this.dom.voiceSelect.value = enVoice.name;
        } else if (faVoice) {
            this.selectedVoice = faVoice;
            this.dom.voiceSelect.value = faVoice.name;
        } else if (enVoice) {
            this.selectedVoice = enVoice;
            this.dom.voiceSelect.value = enVoice.name;
        } else if (this.voices.length > 0) {
            this.selectedVoice = this.voices[0];
            this.dom.voiceSelect.value = this.voices[0].name;
        }
        if(this.selectedVoice) {
            localStorage.setItem('selectedVoiceName', this.selectedVoice.name);
        }
    },

    selectVoice: function() {
        if (!this.dom.voiceSelect) return;
        const selectedVoiceName = this.dom.voiceSelect.value;
        this.selectedVoice = this.voices.find(voice => voice.name === selectedVoiceName);
        localStorage.setItem('selectedVoiceName', selectedVoiceName);
        if (this.selectedVoice) {
            const l = this.lang[this.currentLang];
            this.speak(l.voiceChangeAnnounce.replace('{{voiceName}}', this.selectedVoice.name), this.selectedVoice.lang);
        }
    },

    setSpeechRate: function() {
        if (!this.dom.speechRateInput || !this.dom.speechRateValueSpan) return;
        this.speechRate = parseFloat(this.dom.speechRateInput.value);
        this.dom.speechRateValueSpan.textContent = `${this.speechRate.toFixed(1)}x`;
        localStorage.setItem('speechRate', this.speechRate);
        const l = this.lang[this.currentLang];
        this.speak(l.speedChangeAnnounce.replace('{{speed}}', this.speechRate.toFixed(1)));
    },

    loadSpeechSettings: function() {
        const savedRate = localStorage.getItem('speechRate');
        if (savedRate !== null) {
            this.speechRate = parseFloat(savedRate);
        }
        if (this.dom.speechRateInput) this.dom.speechRateInput.value = this.speechRate;
        if (this.dom.speechRateValueSpan) this.dom.speechRateValueSpan.textContent = `${this.speechRate.toFixed(1)}x`;
    },

    // --- Handle Main Grid Button Clicks ---
    handleButtonClick: function(type) {
        const l = this.lang[this.currentLang];
        let narrationText = '';
        let targetModalType = '';

        switch (type) {
            case 'clock':
                const location = this.currentElderData?.location || 'America/Toronto';
                narrationText = this.getCurrentClockText(this.currentLang === 'fa' ? 'fa-IR' : 'en-US', location);
                this.speak(narrationText);
                return;
            case 'reminders':
                narrationText = l.openingReminders;
                targetModalType = 'reminders';
                break;
            case 'family':
                narrationText = l.openingFamily;
                targetModalType = 'family';
                break;
            case 'call':
                narrationText = l.openingCallOptions;
                targetModalType = 'call';
                break;
            case 'money':
                narrationText = l.openingMoneyNotes;
                targetModalType = 'money';
                break;
            case 'meet':
                narrationText = l.openingGoogleMeet;
                const meetLink = this.currentElderData?.meetLink || 'https://meet.google.com/';
                window.open(meetLink, '_blank');
                this.speak(narrationText);
                return;
            case 'notes':
                narrationText = l.openingPersonalNotes;
                targetModalType = 'notes';
                break;
            case 'help':
                narrationText = l.openingHelpGuide;
                targetModalType = 'help';
                break;
            case 'youtube': // New button type for YouTube
                narrationText = l.openingYouTubeVideo;
                targetModalType = 'youtube';
                break;
        }
        this.showModal(targetModalType, narrationText);
    },

    getCurrentClockText: function(langCode, location) {
        const now = new Date();
        const timeOptions = { timeZone: location, hour: 'numeric', minute: 'numeric', hour12: true };
        const dateOptions = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', timeZone: location };

        let timeText, dateText;
        if (langCode.startsWith('fa')) {
            timeText = now.toLocaleTimeString('fa-IR', timeOptions);
            dateText = now.toLocaleDateString('fa-IR-u-ca-persian', dateOptions);
            return this.lang.fa.currentClockText
                .replace('${time}', timeText)
                .replace('${date}', dateText)
                .replace('${location}', location.split('/')[1] || location);
        } else { // en-US
            timeText = now.toLocaleTimeString('en-US', timeOptions);
            dateText = now.toLocaleDateString('en-US', dateOptions);
            return this.lang.en.currentClockText
                .replace('{{time}}', timeText)
                .replace('{{date}}', dateText)
                .replace('{{location}}', location.split('/')[1] || location);
        }
    },

    // --- Modal Handling ---
    showModal: function(modalType, narrationText) {
        const modalElement = document.getElementById(`${modalType}Modal`);
        if (modalElement) {
            modalElement.style.display = 'flex';
            this.speak(narrationText || this.lang[this.currentLang].windowClosed);

            // Load content specific to the modal
            switch (modalType) {
                case 'reminders': this.loadReminders(); break;
                case 'family': this.populateFamilyContent(this.currentElderData?.familyImage, this.currentElderData?.imageCaption); break;
                case 'call': this.populateCallContacts(this.currentElderData?.emergencyContact, this.currentElderData?.quickButtons); break;
                case 'money': this.loadMoneyNotes(); break;
                case 'notes': this.loadPersonalNotes(); break;
                case 'youtube': this.embedYouTubeVideo(this.currentElderData?.youtubeVideoId); break; // Embed YouTube video
            }
        }
    },

    hideModal: function(modalType) {
        const modalElement = document.getElementById(`${modalType}Modal`);
        if (modalElement) {
            modalElement.style.display = 'none';
            // If it's the YouTube modal, stop the video when closing
            if (modalType === 'youtube') {
                this.dom.youtubePlayerContainer.innerHTML = ''; // Clear the iframe
            }
            const l = this.lang[this.currentLang];
            const spokenText = `${l[`${modalType}ModalTitle`] || l.windowClosed} ${l.windowClosed}`;
            this.speak(spokenText);
        }
    },

    // --- Supabase Authentication & Data Management ---
    currentElderData: null, // Cache the most recent elder data for quick access

    async promptCaregiverLogin() {
        const email = prompt(this.lang[this.currentLang].enterEmailPrompt || "Enter caregiver email:"); // Assuming you add enterEmailPrompt to lang
        const password = prompt(this.lang[this.currentLang].enterPasswordPrompt);

        if (!email || !password) {
            this.showStatusMessage("Email and password cannot be empty.", 'error');
            return;
        }

        try {
            const { data, error } = await supabase.auth.signInWithPassword({ email, password });
            if (error) throw error;

            this.elderUserId = data.user.id; // Use caregiver's UID as elder's ID for simplicity
            localStorage.setItem('elderUserId', this.elderUserId);
            this.elderUserDocRef = supabase.from('memory_settings');

            this.showStatusMessage(this.lang[this.currentLang].passwordSetSuccess);
            this.dom.caregiverSection.classList.remove('hidden');
            this.loadCaregiverSettings();
            this.listenForElderSettingsChanges(); // Start real-time listener for caregiver's device

        } catch (error) {
            console.error("Supabase Login Failed:", error);
            this.showStatusMessage(`Login failed: ${error.message}`, 'error');
        }
    },

    async handleCaregiverFormSubmit(e) {
        e.preventDefault();

        if (!this.elderUserId) {
            this.showStatusMessage("Error: Elder user not identified. Please login caregiver.", 'error');
            return;
        }

        const dataToSave = {
            user_id: this.elderUserId,
            userName: this.dom.userNameInput.value,
            location: this.dom.locationInput.value,
            emergencyContact: this.dom.emergencyContactInput.value,
            meetLink: this.dom.meetLinkInput.value,
            dailyReminder: this.dom.dailyReminderTextarea.value,
            imageCaption: this.dom.imageCaptionInput.value,
            quickButtons: this.dom.quickButtonsInput.value,
            youtubeVideoId: this.dom.youtubeVideoIdInput.value // Save YouTube ID/URL
        };

        // --- Image Upload to Supabase Storage ---
        const imageFile = this.dom.familyImageInput.files[0];
        if (imageFile) {
            try {
                this.showStatusMessage("Uploading image...", 'info');
                const { data: uploadData, error: uploadError } = await supabase.storage
                    .from('media') // Your Supabase Storage bucket name
                    .upload(`${this.elderUserId}/family_image/${imageFile.name}`, imageFile, {
                        cacheControl: '3600',
                        upsert: true
                    });
                if (uploadError) throw uploadError;
                dataToSave.familyImage = `${supabaseUrl}/storage/v1/object/public/media/${uploadData.path}`;
                this.showStatusMessage("Image uploaded!");
            } catch (error) {
                console.error("Image upload failed:", error);
                this.showStatusMessage("Image upload failed.", 'error');
            }
        } else {
            // If no new file, try to keep the existing image URL from currentElderData
            if (this.currentElderData && this.currentElderData.familyImage) {
                dataToSave.familyImage = this.currentElderData.familyImage;
            } else {
                dataToSave.familyImage = null; // Explicitly set to null if no image and no existing
            }
        }

        // --- Custom Sound Upload to Supabase Storage ---
        const soundFile = this.dom.customSoundInput.files[0];
        if (soundFile) {
            try {
                this.showStatusMessage("Uploading sound...", 'info');
                const { data: uploadData, error: uploadError } = await supabase.storage
                    .from('media') // Your Supabase Storage bucket name
                    .upload(`${this.elderUserId}/custom_sound/${soundFile.name}`, soundFile, {
                        cacheControl: '3600',
                        upsert: true
                    });
                if (uploadError) throw uploadError;
                dataToSave.customSound = `${supabaseUrl}/storage/v1/object/public/media/${uploadData.path}`;
                this.showStatusMessage("Sound uploaded!");
            } catch (error) {
                console.error("Sound upload failed:", error);
                this.showStatusMessage("Sound upload failed.", 'error');
            }
        } else {
            // Preserve existing custom sound URL
            if (this.currentElderData && this.currentElderData.customSound) {
                dataToSave.customSound = this.currentElderData.customSound;
            } else {
                dataToSave.customSound = null;
            }
        }

        // --- Save all settings to Supabase Table ---
        try {
            const { error } = await supabase.from('memory_settings').upsert(dataToSave, { onConflict: 'user_id' });
            if (error) throw error;
            this.showStatusMessage(this.lang[this.currentLang].settingsSaved);
            // Data will be re-rendered by the real-time listener or on next load
        } catch (error) {
            console.error("Error saving settings to Supabase:", error);
            this.showStatusMessage("Failed to save settings to cloud.", 'error');
        }
    },

    async loadCaregiverSettings() {
        if (!this.elderUserId) {
            this.dom.userNameInput.value = '';
            this.dom.locationInput.value = 'America/Toronto';
            this.dom.emergencyContactInput.value = '';
            this.dom.meetLinkInput.value = '';
            this.dom.dailyReminderTextarea.value = '';
            this.dom.imageCaptionInput.value = '';
            this.dom.quickButtonsInput.value = '';
            this.dom.youtubeVideoIdInput.value = '';
            this.renderUserView();
            return;
        }

        try {
            const { data, error } = await supabase.from('memory_settings').select('*').eq('user_id', this.elderUserId).single();
            if (error && error.code !== 'PGRST116') throw error; // PGRST116 means no rows found

            if (data) {
                this.currentElderData = data; // Cache the data
                this.dom.userNameInput.value = data.userName || '';
                this.dom.locationInput.value = data.location || 'America/Toronto';
                this.dom.emergencyContactInput.value = data.emergencyContact || '';
                this.dom.meetLinkInput.value = data.meetLink || '';
                this.dom.dailyReminderTextarea.value = data.dailyReminder || '';
                this.dom.imageCaptionInput.value = data.imageCaption || '';
                this.dom.quickButtonsInput.value = data.quickButtons || '';
                this.dom.youtubeVideoIdInput.value = data.youtubeVideoId || '';
            } else {
                this.currentElderData = {}; // No data found
                this.dom.userNameInput.value = '';
                this.dom.locationInput.value = 'America/Toronto';
                this.dom.emergencyContactInput.value = '';
                this.dom.meetLinkInput.value = '';
                this.dom.dailyReminderTextarea.value = '';
                this.dom.imageCaptionInput.value = '';
                this.dom.quickButtonsInput.value = '';
                this.dom.youtubeVideoIdInput.value = '';
            }
            this.renderUserView();
        } catch (error) {
            console.error("Error loading caregiver settings from Supabase:", error);
            this.showStatusMessage("Failed to load settings from cloud. Please check network.", 'error');
            this.currentElderData = {}; // Clear data on error
            this.renderUserView();
        }
    },

    // --- User View Rendering ---
    async renderUserView() {
        const l = this.lang[this.currentLang];
        let data = null;

        if (!this.elderUserId) {
            this.dom.userView.innerHTML = `<p>${l.noSettings}</p>`;
            this.updateClock('America/Toronto');
            return;
        }

        try {
            const { data: fetchedData, error } = await supabase.from('memory_settings').select('*').eq('user_id', this.elderUserId).single();
            if (error && error.code !== 'PGRST116') throw error;
            data = fetchedData;
            this.currentElderData = data; // Cache for other functions
        } catch (error) {
            console.error("Error fetching user data for rendering:", error);
            this.showStatusMessage("Could not load user data. Check internet connection.", 'error');
            data = {}; // Fallback to empty data
        }

        if (!data || Object.keys(data).length === 0 || !data.userName) {
            this.dom.userView.innerHTML = `<p>${l.noSettings}</p>`;
            this.updateClock('America/Toronto');
            return;
        }

        let html = `<h2 class="user-name-display">${data.userName || ''}</h2>`;
        html += `<p><strong>${l.reminderText}</strong> ${data.dailyReminder || ''}</p>`;
        html += `<p><strong>${l.emergencyContactText}</strong> ${data.emergencyContact || ''}</p>`;

        // Google Meet Link Display
        if (data.meetLink) {
            html += `<p><strong>${l.googleMeetText}</strong> <a href="${data.meetLink}" target="_blank" onclick="app.speak('${l.openingGoogleMeet}');">${l.joinCall}</a></p>`;
        }
        
        // Family Image Display
        if (data.familyImage) {
            html += `<img src="${data.familyImage}" alt="Family Image" />`;
            if (data.imageCaption) {
                html += `<p>${data.imageCaption}</p>`;
            }
        }

        this.dom.userView.innerHTML = html;
        this.updateClock(data.location);

        // Populate dynamic quick buttons
        this.populateDynamicQuickButtons(data.quickButtons);

        // Play custom sound on initial load/render
        if (data.customSound) {
            this.customAudio = new Audio(data.customSound);
            this.customAudio.addEventListener('ended', () => {
                if (this.narrationEnabled && data.dailyReminder) {
                    this.speak(l.speechReminder + ' ' + data.dailyReminder);
                }
            });
            this.customAudio.play().catch(e => console.error("Error playing custom sound:", e));
        } else {
            this.customAudio = null;
            // If no custom sound, speak all initial data
            if (this.narrationEnabled) {
                this.speakAll(data);
            }
        }
    },

    populateCallContacts: function(emergencyContact, quickButtons) {
        if (!this.dom.phoneNumberSelect) return;
        this.dom.phoneNumberSelect.innerHTML = `<option value="" id="selectContactOption"></option>`;
        this.dom.selectContactOption.innerText = this.lang[this.currentLang].selectContact;

        if (emergencyContact) {
            const [name, number] = emergencyContact.split(':').map(s => s.trim());
            if (name && number) {
                const option = document.createElement('option');
                option.value = `tel:${number}`;
                option.textContent = `${name} (${number})`;
                this.dom.phoneNumberSelect.appendChild(option);
            }
        }
        // Quick buttons that are calls are handled by populateDynamicQuickButtons now
    },

    populateFamilyContent: function(familyImage, imageCaption) {
        if (!this.dom.familyContentDiv) return;
        this.dom.familyContentDiv.innerHTML = '';
        const l = this.lang[this.currentLang];

        if (familyImage) {
            const img = document.createElement('img');
            img.src = familyImage;
            img.alt = 'Family Image';
            this.dom.familyContentDiv.appendChild(img);

            if (imageCaption) {
                const captionP = document.createElement('p');
                captionP.innerText = imageCaption;
                this.dom.familyContentDiv.appendChild(captionP);
            }
        } else {
            const p = document.createElement('p');
            p.innerText = l.familyPlaceholderMsg;
            this.dom.familyContentDiv.appendChild(p);
        }
    },

    populateDynamicQuickButtons: function(quickButtonsString) {
        if (!this.dom.dynamicQuickButtonsContainer) return;
        this.dom.dynamicQuickButtonsContainer.innerHTML = '';

        if (quickButtonsString) {
            const buttons = quickButtonsString.split(',').map(b => b.trim()).filter(Boolean);
            buttons.forEach(buttonText => {
                const button = document.createElement('button');
                button.classList.add('quick-button');
                button.innerText = buttonText;
                button.onclick = () => this.handleQuickButtonClick(buttonText);
                this.dom.dynamicQuickButtonsContainer.appendChild(button);
            });
        }
    },

    handleQuickButtonClick: function(buttonText) {
        this.speakOrPlay(buttonText); // Speak or play custom sound

        const lowerCaseText = buttonText.toLowerCase();
        // Example of more complex actions based on button text
        if (lowerCaseText.startsWith('call')) {
            const parts = buttonText.split(':').map(s => s.trim());
            if (parts.length === 2 && parts[1]) {
                this.speak(this.lang[this.currentLang].attemptingToCall.replace('{{contactName}}', parts[0]));
                window.location.href = `tel:${parts[1]}`;
            }
        } else if (lowerCaseText.includes('meds')) {
            this.speak(`It's time for your medication.`);
        } else if (lowerCaseText.includes('youtube') && this.currentElderData?.youtubeVideoId) {
            this.handleButtonClick('youtube'); // Trigger YouTube modal
        }
        // Add more conditions for other custom actions
    },

    speakOrPlay: function(text) {
        if (this.customAudio) {
            this.customAudio.play().catch(e => console.error("Error playing custom audio on click:", e));
        } else {
            this.speak(text);
        }
    },

    embedYouTubeVideo: function(videoIdOrUrl) {
        if (!this.dom.youtubePlayerContainer) return;
        this.dom.youtubePlayerContainer.innerHTML = ''; // Clear previous video

        let videoId = videoIdOrUrl;
        // Extract video ID from URL if a full URL is provided
        const youtubeUrlRegex = /(?:https?:\/\/)?(?:www\.)?(?:m\.)?(?:youtube\.com|youtu\.be)\/(?:watch\?v=|embed\/|v\/|)([\w-]{11})(?:\S+)?/i;
        const match = videoIdOrUrl.match(youtubeUrlRegex);
        if (match && match[1]) {
            videoId = match[1];
        }

        if (videoId) {
            const iframe = document.createElement('iframe');
            iframe.src = `https://www.youtube.com/embed/${videoId}?autoplay=1`;
            iframe.setAttribute('frameborder', '0');
            iframe.setAttribute('allow', 'accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture');
            iframe.setAttribute('allowfullscreen', '');
            iframe.style.width = '100%';
            iframe.style.height = '100%';
            
            const responsiveDiv = document.createElement('div');
            responsiveDiv.classList.add('youtube-responsive-container');
            responsiveDiv.appendChild(iframe);

            this.dom.youtubePlayerContainer.appendChild(responsiveDiv);
            this.speak(this.lang[this.currentLang].openingYouTubeVideo);
        } else {
            this.dom.youtubePlayerContainer.innerHTML = `<p>${this.lang[this.currentLang].noYouTubeVideo || "No YouTube video set."}</p>`;
            this.speak(this.lang[this.currentLang].noYouTubeVideo || "No YouTube video set.");
        }
    },


    // NEW: Real-time listener for elder's settings
    listenForElderSettingsChanges: function() {
        if (!this.elderUserId) return;

        // Supabase real-time subscription
        supabase
            .channel(`memory_settings_changes:${this.elderUserId}`)
            .on('postgres_changes', { event: '*', schema: 'public', table: 'memory_settings', filter: `user_id=eq.${this.elderUserId}` }, payload => {
                console.log('Real-time update received:', payload);
                this.currentElderData = payload.new; // Update cached data
                this.renderUserView(); // Re-render the user view immediately
                // If the caregiver section is open, also update its form fields
                if (!this.dom.caregiverSection.classList.contains('hidden')) {
                    this.loadCaregiverSettings(); // Reloads form fields from DB
                }
            })
            .subscribe();
    },

    // --- Clock and Date Update ---
    updateClock: function(location) {
        const date = new Date();
        const l = this.lang[this.currentLang];
        let timeText, dateText;

        try {
            const timeOptions = { hour: 'numeric', minute: 'numeric', hour12: true, timeZone: location };
            timeText = date.toLocaleTimeString('en-US', timeOptions);

            const persianDateOptions = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', timeZone: location };
            dateText = new Intl.DateTimeFormat('fa-IR-u-ca-persian', persianDateOptions).format(date);

            if (this.dom.clockDisplay) {
                this.dom.clockDisplay.innerHTML = l.timeDisplay
                    .replace('{{location}}', location.split('/')[1] || location)
                    .replace('{{time}}', timeText)
                    .replace('{{date}}', dateText);
            }

        } catch (e) {
            if (this.dom.clockDisplay) {
                this.dom.clockDisplay.innerText = l.invalidLocation;
            }
            console.error("Error updating clock:", e);
        }
    },

    // --- Reminders Functionality (Firestore-like structure on Supabase) ---
    async loadReminders() {
        if (!this.elderUserId) {
            if (this.dom.remindersListUl) this.dom.remindersListUl.innerHTML = `<li>${this.lang[this.currentLang].noReminders}</li>`;
            return;
        }

        try {
            const { data, error } = await supabase.from('reminders').select('*').eq('user_id', this.elderUserId).order('createdAt', { ascending: true });
            if (error) throw error;

            if (this.dom.remindersListUl) {
                this.dom.remindersListUl.innerHTML = '';
                if (data.length === 0) {
                    this.dom.remindersListUl.innerHTML = `<li>${this.lang[this.currentLang].noReminders}</li>`;
                    return;
                }

                data.forEach(reminder => {
                    const listItem = document.createElement('li');
                    listItem.innerHTML = `
                        <span>${reminder.text}</span>
                        <button class="delete-reminder-btn" data-id="${reminder.id}">&times;</button>
                    `;
                    this.dom.remindersListUl.appendChild(listItem);
                });

                document.querySelectorAll('#remindersList .delete-reminder-btn').forEach(button => {
                    button.onclick = (event) => {
                        this.deleteReminder(event.target.dataset.id, event.target.previousElementSibling.innerText);
                    };
                });
            }
        } catch (error) {
            console.error("Error loading reminders:", error);
            this.showStatusMessage("Failed to load reminders.", 'error');
        }
    },

    async addReminder() {
        const newReminderText = this.dom.newReminderTextInput.value.trim();
        const l = this.lang[this.currentLang];

        if (!newReminderText) {
            this.speak(l.enterReminderPrompt);
            return;
        }
        if (!this.elderUserId) {
            this.showStatusMessage("Error: Elder user not identified to add reminder.", 'error');
            return;
        }

        try {
            const { error } = await supabase.from('reminders').insert([
                { user_id: this.elderUserId, text: newReminderText, createdAt: new Date().toISOString() }
            ]);
            if (error) throw error;
            this.dom.newReminderTextInput.value = '';
            this.loadReminders(); // Re-load to update UI
            this.speak(l.reminderAdded.replace('{{text}}', newReminderText));
        } catch (error) {
            console.error("Error adding reminder:", error);
            this.showStatusMessage("Failed to add reminder.", 'error');
        }
    },

    async deleteReminder(reminderId, reminderText) {
        const l = this.lang[this.currentLang];

        // IMPORTANT: For a PWA, replace `confirm` with a custom modal for better UX.
        if (confirm(l.deleteReminderConfirm)) {
            if (!this.elderUserId) {
                this.showStatusMessage("Error: Elder user not identified to delete reminder.", 'error');
                return;
            }
            try {
                const { error } = await supabase.from('reminders').delete().eq('id', reminderId); // Assuming 'id' is the primary key for reminders
                if (error) throw error;
                this.loadReminders(); // Re-load to update UI
                this.speak(l.reminderDeleted.replace('{{text}}', reminderText));
            } catch (error) {
                console.error("Error deleting reminder:", error);
                this.showStatusMessage("Failed to delete reminder.", 'error');
            }
        } else {
            this.speak(l.reminderDeleteCancelled);
        }
    },

    // --- Call Functionality ---
    makeCall: function() {
        const selectedValue = this.dom.phoneNumberSelect.value;
        const selectedText = this.dom.phoneNumberSelect.options[this.dom.phoneNumberSelect.selectedIndex].text;
        const l = this.lang[this.currentLang];

        if (selectedValue) {
            this.speak(l.attemptingToCall.replace('{{contactName}}', selectedText));
            window.location.href = selectedValue;
        } else {
            this.speak(l.selectContactToCall);
        }
    },

    // --- Money Notes Functionality (Using Supabase) ---
    async saveMoneyNotes() {
        const notes = this.dom.moneyNotesTextarea.value;
        const l = this.lang[this.currentLang];

        if (!this.elderUserId) {
            this.showStatusMessage("Error: Elder user not identified to save money notes.", 'error');
            return;
        }
        try {
            // Upsert directly into the elder's main settings document
            const { error } = await supabase.from('memory_settings').upsert({ user_id: this.elderUserId, moneyNotes: notes }, { onConflict: 'user_id' });
            if (error) throw error;
            this.speak(l.moneyNotesSaved);
            this.hideModal('money');
        } catch (error) {
            console.error("Error saving money notes:", error);
            this.showStatusMessage("Failed to save money notes.", 'error');
        }
    },

    async loadMoneyNotes() {
        const l = this.lang[this.currentLang];
        if (this.dom.moneyNotesTextarea) this.dom.moneyNotesTextarea.placeholder = l.moneyNotesPlaceholder;
        
        if (!this.elderUserId) {
            if (this.dom.moneyNotesTextarea) this.dom.moneyNotesTextarea.value = '';
            return;
        }
        try {
            const { data, error } = await supabase.from('memory_settings').select('moneyNotes').eq('user_id', this.elderUserId).single();
            if (error && error.code !== 'PGRST116') throw error;
            if (this.dom.moneyNotesTextarea) this.dom.moneyNotesTextarea.value = data?.moneyNotes || '';
        } catch (error) {
            console.error("Error loading money notes:", error);
            this.showStatusMessage("Failed to load money notes.", 'error');
            if (this.dom.moneyNotesTextarea) this.dom.moneyNotesTextarea.value = '';
        }
    },

    // --- Personal Notes Functionality (Using Supabase) ---
    async savePersonalNotes() {
        const notes = this.dom.personalNotesTextarea.value;
        const l = this.lang[this.currentLang];

        if (!this.elderUserId) {
            this.showStatusMessage("Error: Elder user not identified to save personal notes.", 'error');
            return;
        }
        try {
            // Upsert directly into the elder's main settings document
            const { error } = await supabase.from('memory_settings').upsert({ user_id: this.elderUserId, personalNotes: notes }, { onConflict: 'user_id' });
            if (error) throw error;
            this.speak(l.personalNotesSaved);
            this.hideModal('notes');
        } catch (error) {
            console.error("Error saving personal notes:", error);
            this.showStatusMessage("Failed to save personal notes.", 'error');
        }
    },

    async loadPersonalNotes() {
        const l = this.lang[this.currentLang];
        if (this.dom.personalNotesTextarea) this.dom.personalNotesTextarea.placeholder = l.personalNotesPlaceholder;

        if (!this.elderUserId) {
            if (this.dom.personalNotesTextarea) this.dom.personalNotesTextarea.value = '';
            return;
        }
        try {
            const { data, error } = await supabase.from('memory_settings').select('personalNotes').eq('user_id', this.elderUserId).single();
            if (error && error.code !== 'PGRST116') throw error;
            if (this.dom.personalNotesTextarea) this.dom.personalNotesTextarea.value = data?.personalNotes || '';
        } catch (error) {
            console.error("Error loading personal notes:", error);
            this.showStatusMessage("Failed to load personal notes.", 'error');
            if (this.dom.personalNotesTextarea) this.dom.personalNotesTextarea.value = '';
        }
    }
};

// Initialize the app when the DOM is fully loaded
document.addEventListener('DOMContentLoaded', () => {
    app.init();
});